#define MEMSIZE 4096*100

#include "../lib/io.h"
#include "../lib/gui.h"
#include "../lib/math.h"
#include "../lib/random.h"
#include "../lib/draw_buf.h"

proc_info Form;

DrawBufer canvas;

void main()
{
	initStars();
	loop() {
		WaitEventTimeout(1);
		switch(EAX & 0xFF)
		{
			case evButton:
				ExitProcess();
				break;
			case evReDraw:
				DefineAndDrawWindow(215,100,500+9,400+skin_height+4,0x73,0xFFFFFF,"Window header");
				GetProcessInfo(#Form, SelfInfo);
				canvas.zoom = 1;
				canvas.Init(0, 0, Form.cwidth, Form.cheight);
				break;
			default:
				if (buf_data) drawStars();
		}
	}
}

#define MAX_DEPTH 32;
#define STARS_COUNT 512

struct star
{
	int x;
	int y;
	float z;
} stars[STARS_COUNT];

int randomRange(int minVal,maxVal) {
	float rand;
	rand = random(100)/100;
	return math.floor( maxVal - minVal - 1 * rand ) + minVal;
}

void initStars() {
	int i;
	for( i = 0; i < STARS_COUNT; i++ ) {
		stars[i].x = randomRange(-25,25);
		stars[i].y = randomRange(-25,25);
		stars[i].z = randomRange(1,MAX_DEPTH);
	}
}

void drawStars() {
	float k;
	float temp;
	int i, shade, px, py, size;
	int halfWidth  = Form.cwidth / 2;
	int halfHeight = Form.cheight / 2;
	dword color;

	canvas.Fill(0);

	for( i = 0; i < STARS_COUNT; i++ ) 
	{
		stars[i].z -= 0.2;

		if( stars[i].z <= 0 ) {
			stars[i].x = randomRange(-25,25);
			stars[i].y = randomRange(-25,25);
			stars[i].z = MAX_DEPTH;
		}

		k  = 128.0 / stars[i].z;
		px = math.ceil(stars[i].x * k + halfWidth);
		py = math.ceil(stars[i].y * k + halfHeight);

		if( (px >= 0) && (px + 5 <= Form.cwidth) && (py >= 0) && (py + 5 <= Form.cheight) ) {
			temp = stars[i].z / 32.0;
			size = math.ceil(1 - temp * 5);
			shade = math.ceil(1 - stars[i].z * 255 / 32);
			color = calc(shade << 16) + calc(shade << 8) + shade;
			canvas.DrawBar(px, py, size, size, color);
		}
	}
	canvas.Show();
}

/*

    MAX_DEPTH = 32;
    
    var canvas, ctx;
    var stars = new Array(512);
    
    window.onload = function() {
      canvas = document.getElementById("tutorial");
      if( canvas && canvas.getContext ) {
        ctx = canvas.getContext("2d");
        initStars();
        setInterval(loop,33);
       }
    }

    // Returns a random number in the range [minVal,maxVal] 
    function randomRange(minVal,maxVal) {
      return Math.floor(Math.random() * (maxVal - minVal - 1)) + minVal;
    }

    function initStars() {
      for( var i = 0; i < stars.length; i++ ) {
        stars[i] = {
          x: randomRange(-25,25),
          y: randomRange(-25,25),
          z: randomRange(1,MAX_DEPTH)
         }
      }
    }

    function loop() {
      var halfWidth  = canvas.width / 2;
      var halfHeight = canvas.height / 2;
      
      ctx.fillStyle = "rgb(0,0,0)";
      ctx.fillRect(0,0,canvas.width,canvas.height);

      for( var i = 0; i < stars.length; i++ ) {
        stars[i].z -= 0.2;

        if( stars[i].z <= 0 ) {
          stars[i].x = randomRange(-25,25);
          stars[i].y = randomRange(-25,25);
          stars[i].z = MAX_DEPTH;
        }

        var k  = 128.0 / stars[i].z;
        var px = stars[i].x * k + halfWidth;
        var py = stars[i].y * k + halfHeight;

        if( px >= 0 && px <= 500 && py >= 0 && py <= 400 ) {
          var size = (1 - stars[i].z / 32.0) * 5;
          var shade = parseInt((1 - stars[i].z / 32.0) * 255);
          ctx.fillStyle = "rgb(" + shade + "," + shade + "," + shade + ")";
          ctx.fillRect(px,py,size,size);
        }
      }
    }
  
 */
